#include  <stdio.h>
#include <string.h>
#include <unistd.h>
#include <math.h>  

#include <nicklib.h>
#include <getpars.h> 
#include "admutils.h"
#include "mcio.h"  
#include "gammas.h" 
#include "tlest.h" 
#include "arms.h" 
#include "mcmcpars.h" 

/** 
 like admgd2 
 but tests  a range of snps
*/

int keeptrashfiles = YES ; 
int magicnum = -1 ;

int lonum = -1, hinum ; 

int  allsnps   = NO ;
char *losnpname = NULL ;
char *hisnpname = NULL ;

int *fchrom, *lchrom ;

char *trashdir = "/var/tmp" ;
int qtmode = NO ;
int verbose = NO ;
int debug = NO ;

extern int packmode ;

Indiv **indivmarkers;
SNP **snpmarkers ;

int numsnps, numindivs ; 
int xchrom = -1 ;

double plo = .001 ;
double phi = .999 ;
double fakespacing = 0.01 ; 

double disnum = 0.0, dissum = 0.0 ;

char  *genotypename = NULL ;
char  *snpname = NULL ;
char  *genooutfilename = NULL ;
char  *indivname = NULL ;
char *badsnpname = NULL ;
char *tlname  = NULL ;
char *freqname  = NULL ;
char *gammafiles = NULL ;


double **ax[3] ; 
double **bx[3] ; 

#define VERSION    "1000"  

void readcommands(int argc, char **argv) ;
void dosub3(SNP *cupt1, SNP *cupt2, SNP *cupt3)  ;

void
loadxx(double *xx, double xa1, double ya1, double xa2, double ya2, 
 double xe1, double ye1, double xe2, double ye2, 
 double xa3, double ya3, double xe3, double ye3) ;

void
unloadxx(double *xx, double *xa1, double *ya1, double *xa2, double *ya2, 
 double *xe1, double *ye1, double *xe2, double *ye2,
 double *xa3, double *ya3, double *xe3, double *ye3)  ;

void
doit(int *xg1, int *xg2, int *xg3, int n, 
  SNP *cupt1, SNP *cupt2, SNP *cupt3)  ;

double xlike4(SNP **snplist,  int *xgood, 
 Indiv **indm, int numind) ;

double score3(SNP *cupt1, SNP *cupt2, SNP *cupt3, Indiv *indx,
 double *aaa, double *bbb, double dis1, double dis2)  ;

void astep1(double *aa, double *aaa, SNP *cupt, Indiv *indx, double dis)  ;
void bstep1(double *bb, double *bbb, SNP *cupt, Indiv *indx, double dis)  ;
void cfq(SNP *cupt)  ;
double addloga(double *x, int n)   ;
void setfc(SNP **snpm, int numsnps)  ;
double scorex(SNP **snplist, int nlist, Indiv *indx,
 double *aaa, double *bbb, double *dd)  ;

int   
main  (int argc , char **argv) 
{
  int i, j, k ;
  double pa1, pa2, pe1, pe2, pp, pa3, pe3 ;
  double xa1, xa2, ya1, ya2, xe1, xe2, ye1, ye2 ;
  double xa3, ya3, xe3, ye3 ;
  double y ;
  double dis = 0.1 ;  /* Morgans */
  int gg[2] ;

  SNP *cupt ;
  SNP *cupt1, *cupt2, *cupt3 ;

  Indiv *indx ;

  double gpos1,gpos2,cpos1,cpos2,gd, cd, gd100 ;
  double rthresh, zt ;
  int numvind  ;

  int ch1, ch2 ;
  int fmnum , lmnum ;
  int numind ;
  int num, n1, n2, x1, x2, x3, x  ;

  int nindiv = 0, e, f, lag=1  ;
  int nignore, numrisks = 1 ;
  double dmean, dsd ;

  packmode = NO ;
  readcommands(argc, argv) ;

  numsnps = 
    getsnps(snpname, &snpmarkers, fakespacing, badsnpname, &nignore, numrisks) ;


  numindivs = getindivs(indivname, &indivmarkers) ;
  setstatus(indivmarkers, numindivs, "Case") ;

  getgenos(genotypename, snpmarkers, indivmarkers, 
    numsnps, numindivs, nignore) ;

  setfc(snpmarkers, numsnps) ;

  numvind = numvalidind(indivmarkers, numindivs) ;
  printf("\n\n") ;
  printf("numindivs: %d valid: %d numsnps: %d nignore: %d\n" ,
    numindivs, numvind, numsnps, nignore) ; 

  if (xchrom > 0)  {  
    k = fchrom[xchrom] ;
    cupt = snpmarkers[k] ;
    losnpname = strdup(cupt -> ID) ;

    k = lchrom[xchrom] ;
    cupt = snpmarkers[k] ;
    hisnpname = strdup(cupt -> ID) ;

    allsnps = NO ;

  }

  if (losnpname == NULL) fatalx("no losnpname\n") ;
  if (hisnpname == NULL) fatalx("no hisnpname\n") ;

  if ( strcmp(losnpname, "ALL") == 0)  allsnps = YES ;
  if ( strcmp(hisnpname, "ALL") == 0)  allsnps = YES ;
  if (allsnps == NO) {
   lonum = snpindex(snpmarkers, numsnps, losnpname) ;
   hinum = snpindex(snpmarkers, numsnps, hisnpname) ;
  }
  else {
   lonum = 0; 
   hinum = numsnps -1 ;
  }
  readtldata(indivmarkers, numindivs, tlname) ;
  if (freqname!=NULL) readfreqdata(snpmarkers, numsnps, freqname) ;

  setgfiles(snpmarkers, numsnps, numindivs, trashdir, gammafiles, 1) ;

  for (j=0; j<3; j++) {
   ax[j] = initarray_2Ddouble(numindivs, 3, 0.0) ; 
   bx[j] = initarray_2Ddouble(numindivs, 3, 0.0) ; 
  }

  clearestdis(snpmarkers, numsnps)  ;   

  x1 = lonum ;  
  for (;;)  {  

   if (x1>hinum) break ;
   cupt1 = snpmarkers[x1] ;  

   if (cupt1 -> ignore) {  
    ++x1 ;  continue ;
   }

   if (cupt1 -> isfake) {  
    ++x1 ;  continue ;
   }
   cupt2 = cupt1 -> pcupt ;  
   if (cupt2 == NULL) {       
     ++x1 ; continue ;
   }
   x2 = cupt2 -> markernum ;
   if (x2>hinum) break ; 

   cupt3 = cupt2 -> pcupt ;  

   if (cupt3 == NULL) {       
     ++x1 ; continue ;
   }
   x3 = cupt3 -> markernum ;
   if (x3>hinum) break ;
   dosub3(cupt1, cupt2, cupt3) ;
   x1 = x2 ;
  }
  return 0 ; 
}

void dosub3(SNP *cupt1, SNP *cupt2, SNP *cupt3) 
{

  int *g1, *g2, *g3 ;
  int a1, a2, a3, g ;
  double *theta, *lambda, tt, ll ;
  double dis ;
  int num, n1, n2, x1, x2, x3, x  ;
  Indiv *indx ;
  int numstates, ignore ; 


  double pa1, pa2, pe1, pe2, pp, pa3, pe3 ;
  double xa1, xa2, ya1, ya2, xe1, xe2, ye1, ye2 ;
  double xa3, ya3, xe3, ye3 ;
  double xx[12] ;
  int k ;  

  if (debug) 
   printf("%15s %15s %15s" ,
     cupt1->ID, cupt2 -> ID, cupt3 -> ID) ;

  
  x1 = cupt1 -> markernum ;
  x2 = cupt2 -> markernum ;
  x3 = cupt3 -> markernum ;


  ZALLOC(g1, numindivs, int) ;
  ZALLOC(g2, numindivs, int) ;
  ZALLOC(g3, numindivs, int) ;
  ZALLOC(theta, numindivs, double) ;
  ZALLOC(lambda, numindivs, double) ;

  for (k=0; k<numindivs; ++k) {  

    indx = indivmarkers[k] ;
    gettln(cupt2, indx, &tt, &ll, &numstates, &ignore) ;

    alphastar(ax[0][k], x1, k, numstates) ;
    alphastar(ax[1][k], x2, k, numstates) ;
    alphastar(ax[2][k], x3, k, numstates) ;
    betax(bx[0][k], x1, k, numstates) ;
    betax(bx[1][k], x2, k, numstates) ;
    betax(bx[2][k], x3, k, numstates) ;


    g1[k] = a1 = getgtypes(cupt1, k) ;
    g2[k] = a2 = getgtypes(cupt2, k) ;
    g3[k] = a3 = getgtypes(cupt3, k) ;
    if (indx -> ignore) { 
      g1[k] = g2[k] = g3[k] = -1 ;
      continue ;
    }

  }

  if (freqname == NULL)  {

  xa1 = cupt1 -> popA_nn[0] ;
  ya1 = cupt1 -> popA_nn[1] ;
  pa1 = cupt1 -> PopA_freq = xa1/(xa1+ya1) ;
  xa2 = cupt2 -> popA_nn[0] ;
  ya2 = cupt2 -> popA_nn[1] ;
  pa2 = cupt2 -> PopA_freq = xa2/(xa2+ya2) ;
  xa3 = cupt3 -> popA_nn[0] ;
  ya3 = cupt3 -> popA_nn[1] ;
  pa3 = cupt3 -> PopA_freq = xa3/(xa3+ya3) ;

  xe1 = cupt1 -> popB_nn[0] ;
  ye1 = cupt1 -> popB_nn[1] ;
  pe1 = cupt1 -> PopB_freq = xe1/(xe1+ye1) ;

  xe2 = cupt2 -> popB_nn[0] ;
  ye2 = cupt2 -> popB_nn[1] ;
  pe2 = cupt2 -> PopB_freq = xe2/(xe2+ye2) ;

  xe3 = cupt3 -> popB_nn[0] ;
  ye3 = cupt3 -> popB_nn[1] ;
  pe3 = cupt3 -> PopB_freq = xe3/(xe3+ye3) ;


  cfq(cupt1) ;
  cfq(cupt2) ;
  cfq(cupt3) ;

  }

  doit(g1, g2, g3, numindivs, cupt1, cupt2, cupt3) ; 

  free(g1) ;
  free(g2) ;
  free(g3) ;
  free(theta) ;
  free(lambda) ;

  return  ;

}

void cfq(SNP *cupt) 
{
 cupt -> adm_PopA_freq = cupt -> PopA_freq ;
 cupt -> adm_PopB_freq = cupt -> adm_PopB_freq ;
}

void
doit(int *xg1, int *xg2, int *xg3, int n, 
  SNP *cupt1, SNP *cupt2, SNP *cupt3) 

{


  int i, *xgood, t=0 ;
  int g1, g2, g3 ; 
  SNP *snplist[3] ;


  ZALLOC(xgood, n, int) ;
  ivclear(xgood, 1, n) ;
  
  for (i=0; i<n; ++i)  { 
    g1 = xg1[i] ;
    g2 = xg2[i] ;
    g3 = xg2[i] ;
    if (g1<0) xgood[i] = 0 ;
    if (g2<0) xgood[i] = 0 ;
    if (g3<0) xgood[i] = 0 ;
  }
  if (debug)  {
   t = intsum(xgood, n) ;
   printf ("number of valid triples %d\n", t) ;
  }

  snplist[0] = cupt1 ;  
  snplist[1] = cupt2 ;  
  snplist[2] = cupt3 ;  

  xlike4(snplist,  xgood, indivmarkers, n) ;
  free(xgood) ;
  return ;

}

double xlike4(SNP **snplist,  int *xgood, 
 Indiv **indm, int numind)
{
 SNP *cupt1, *cupt2, *cupt3 ;
 Indiv *indx ;
 double ytot, yl, ybase ;  
 double *alp, *bet ;
 double totdis ;
 double x0[11], x1[11], x2[11] ; 
 double y0, y1, y2 ;
 double ya, yb, dis0, dis1 ;
 int k, j ;
 int nscore = 0 ;
 double aaa[3], bbb[3], ddis[2], ccc[3], ddd[3] ;  

 int mnum, ignore, numstates ;
 double tjunk, ljunk ;

 cupt1 = snplist[0] ;
 cupt2 = snplist[1] ;
 cupt3 = snplist[2] ;

 ddis[0] = cupt2 -> genpos - cupt1 -> genpos ;
 ddis[1] = cupt3 -> genpos - cupt2 -> genpos ;
 
 vabs(ddis, ddis,2 ) ;

 totdis = asum(ddis, 2) ;
 
 vzero(x0, 11) ;
 vzero(x1, 11) ;
 vzero(x2, 11) ;

 ybase = 0.0 ;

 for (k=0; k<numind; k++) { 
  indx = indm[k] ;
  if (xgood[k] == 0) continue ;
  gettln(cupt1, indx, &tjunk, &ljunk, &numstates, &ignore) ;
  if (ignore) continue ;

  mnum  = cupt1 -> markernum ;
  alphastar(aaa, mnum, k, numstates) ;
  mnum  = cupt3 -> markernum ;
  betax(bbb, mnum, k, numstates) ;

   ybase  += score3(cupt1, cupt2, cupt3,  indx, 
     aaa, bbb, ddis[0], ddis[1]) ;

   astep1(ccc, aaa, cupt1, indx, totdis) ;
   bstep1(ddd, bbb, cupt3, indx, totdis) ;

  for (j=0; j<= 10; ++j)  {  
   ya = ((double) j) / 10.0 ;
   yb = 1.0-ya ;           
   dis0 = ya*totdis ;
   dis1 = yb*totdis ;

   ybase  += score3(cupt1, cupt2, cupt3,  indx, 
     aaa, bbb, ddis[0], ddis[1]) ;

   astep1(ccc, aaa, cupt1, indx, totdis) ;
   bstep1(ddd, bbb, cupt3, indx, totdis) ;


   x0[j]  += score3(cupt1, cupt2, cupt3,  indx, 
     aaa, bbb, dis0, dis1) ;

   x1[j]  += score3(cupt3, cupt2, NULL, indx, 
     ccc, NULL, dis1, 0) ;

   x2[j]  += score3(NULL, cupt2, cupt1, indx, 
     NULL, ddd, 0, dis0) ;
  }
 }

  y0 = addloga(x0, 11) - log(11) ;
  y1 = addloga(x1, 11) - log(11) ;
  y2 = addloga(x2, 11) - log(11) ;

  printf("%15s %3d %12.0f ", cupt2 -> ID, cupt2 -> chrom, cupt2 -> physpos) ;
  printf("base: %9.3f dsize: %4d ",  ybase, intsum(xgood, numind)) ;
  y0 -= ybase ;
  y1 -= ybase ;
  y2 -= ybase ;
  printf("%9.3f  %9.3f  %9.3f\n", y0, y1, y2) ;
   
}

void readcommands(int argc, char **argv) 

{
  int i ;
  char *parname = NULL ;
  phandle *ph ;
  char str[5000]  ;
  char *tempname ;
  int n ;

  while ((i = getopt (argc, argv, "p:vV")) != -1) {

    switch (i)
      {

      case 'p':
	parname = strdup(optarg) ;
	break;

      case 'v':
	printf("version: %s\n", VERSION) ; 
	break; 

      case 'V':
	verbose = YES ;
	break; 

      case '?':
	printf ("Usage: bad params.... \n") ;
	fatalx("bad params\n") ;
      }
  }

         
   pcheck(parname,'p') ;
   printf("parameter file: %s\n", parname) ;
   ph = openpars(parname) ;
   dostrsub(ph) ;

/**
DIR2:  /fg/nfiles/admixdata/ms2
SSSS:  DIR2/outfiles 
genotypename: DIR2/autos_ccshad_fakes
eglistname:    DIR2/eurlist  
output:        eurout
*/
   getint(ph, "packmode:", &packmode) ; // controls internals 

   getstring(ph, "genotypename:", &genotypename) ;
   getstring(ph, "genooutfilename:", &genooutfilename) ;
   getstring(ph, "snpname:", &snpname) ;
   getstring(ph, "indivname:", &indivname) ;
   getstring(ph, "badsnpname:", &badsnpname) ;
   getstring(ph, "tlname:", &tlname) ;
   getstring(ph, "freqname:", &freqname) ;

   getint(ph, "xchrom:", &xchrom) ;

   getstring(ph, "losnpname:", &losnpname) ;
   getstring(ph, "hisnpname:", &hisnpname) ;

   getstring(ph, "trashdir:", &trashdir) ;
   getstring(ph, "gammafiles:", &gammafiles) ;
   getdbl(ph, "fakespacing:", &fakespacing) ;


   writepars(ph) ;
   closepars(ph) ;

}
double addloga(double *x, int n)  
{

 double ylog ; 
 int i ;

 ylog = x[0] ;
 for (i=1; i<n; i++)  {
  ylog = addlog(ylog,  x[i]) ;
 }
 return ylog ;
}

double score3(SNP *cupt1, SNP *cupt2, SNP *cupt3, Indiv *indx,
 double *aaa, double *bbb, double dis1, double dis2) 
{

  double aa[3], bb[3], tt[3] ;
  double X[3] ; 
  double theta, lambda ;
  double z1, z2 ;
  int idnum, ignore, numstates ;

  gettln(cupt2, indx, &theta, &lambda, &numstates, &ignore) ;

  if (ignore) return 0.0 ;
  if ((aaa != NULL) && (aaa[0]<0.0)) return 0.0 ;
  if ((bbb != NULL) && (bbb[0]<0.0)) return 0.0 ;

  vzero(tt, 3) ;
  sett1(tt, theta, numstates) ;
  if ((aaa==NULL) || (cupt1==NULL)) { 
   copyarr(tt, aa, numstates) ;
  }
  else astep1(aa, aaa, cupt1, indx, dis1) ;
  if ((bbb==NULL) || (cupt3==NULL)) { 
   vclear(bb, 1.0, numstates) ;
  }
  else bstep1(bb, bbb, cupt3, indx, dis2) ;
  idnum = indx -> idnum ;
  tcalcX(cupt2, idnum, X, numstates) ;
  vvt(aa, aa, bb, numstates) ;  
  bal1(aa, numstates) ;  
  z1 = vdot(aa, X, numstates) ;
  z2 = vdot(tt, X, numstates) ;
  return log(z1) - log(z2) ;
}

void setfc(SNP **snpm, int numsnps) 
// also allocates fchrom , lchrom
{
  int i, j, chrom ;
  SNP *cupt ;

  ZALLOC(fchrom, 25, int) ;
  ZALLOC(lchrom, 25, int) ;

  ivclear(fchrom, 999999, 25) ;
  ivclear(lchrom, -999999, 25) ;
  
  for (i=0; i<numsnps; i++) {
    cupt = snpm[i] ;
    if (cupt -> isfake) continue ;
    if (cupt -> ignore) continue ;
    chrom = cupt -> chrom ;
    fchrom[chrom] = MIN(fchrom[chrom],i) ;
    lchrom[chrom] = MAX(lchrom[chrom],i) ;
  }

}

void astep1(double *aa, double *aaa, SNP *cupt, Indiv *indx, double dis) 
{
  int idnum, ignore, numstates ;
  int x, y ; 
  double theta, lambda, poisson, temp ;  
  double **M, X[3]  ;
  double alp[3], alp2[3] ;

  M = initarray_2Ddouble(3, 3, 0.0) ; 

  gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;
  temp = lambda * dis ;
  if (temp<20.0) {
    poisson = exp(-temp) ;
  }
  else poisson = 0.0 ;
  calcM(poisson, theta, M, numstates) ;
  idnum = indx -> idnum ;
  tcalcX(cupt, idnum, X, numstates) ;
  vzero(alp2, 3) ;
  vvt(alp, aaa, X, numstates) ;
  for (x=0; x<numstates; x++) {
    for (y=0; y<numstates; y++) {
	  alp2[x] += M[x][y] * alp[y];
/* x is new state y is old */
    }
   }

  free2D(&M, 3) ;
  copyarr(alp2, aa, 3) ;
}

void bstep1(double *bb, double *bbb, SNP *cupt, Indiv *indx, double dis) 
{
  int idnum, ignore, numstates ;
  int x, y ; 
  double theta, lambda, poisson, temp ;  
  double **M, X[3]  ;
  double bet[3], bet2[3] ;

  M = initarray_2Ddouble(3, 3, 0.0) ; 

  gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;
  temp = lambda * dis ;
  if (temp<20.0) {
    poisson = exp(-temp) ;
  }
  else poisson = 0.0 ;
  calcM(poisson, theta, M, numstates) ;
  idnum = indx -> idnum ;
  tcalcX(cupt, idnum, X, numstates) ;
  vzero(bet2, 3) ;
  vvt(bet, bbb, X, numstates) ;
  for (x=0; x<numstates; x++) {
    for (y=0; y<numstates; y++) {
	  bet2[y] += M[x][y] * bet[x];
/* x is new state y is old */
    }
   }

  free2D(&M, 3) ;
  copyarr(bet2, bb, 3) ;
}


double scorex(SNP **snplist, int nlist, Indiv *indx,
 double *aaa, double *bbb, double *dd) 
{

  double aa[3], bb[3], tt[3] ;
  double X[3] ; 
  double theta, lambda ;
  double z1, z2 ;
  int idnum, ignore, numstates ;
  SNP *cupt, *cuptx ;
  int k ;

  cuptx = cupt = snplist[0] ;
  gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;
  if (ignore) return 0.0 ;
  for (k=1; k<nlist; ++k) {  
   cuptx = snplist[k] ;
   if (cuptx -> ignore) return 0.0 ;
  }

  
  if ((aaa != NULL) && (aaa[0]<0.0)) return 0.0 ;
  if ((bbb != NULL) && (bbb[0]<0.0)) return 0.0 ;

  idnum = indx -> idnum ;
  copyarr(bbb, bb, 3) ;
  for (k=nlist-1; k>=1; --k) { 
   cupt = snplist[k] ;  
   bstep1(bb, bb, cupt, indx, dd[k-1]) ;
  }
  cupt = snplist[0] ;
  vvt(aa, aaa, bb, numstates) ;  
  tcalcX(cupt, idnum, X, numstates) ;
  z1 = vdot(aa, X, numstates) ;
  return log(z1)  ;
}
