#include "mcio.h" 
#include "mclm.h" 
#include <math.h>

static double **magictable = NULL ;

void setmagic(char *magicfname, Indiv **indm, int numindivs)  
{

   FILE *fff ;
   char line[MAXSTR] ;
   char *spt[MAXFF], *sx ;
   int nsplit, skipit ;
   int k ;
   double xp[3] ; 
   int indnum ;

   if (magicfname == NULL) return ;
   magictable = initarray_2Ddouble(numindivs, 3, 1.0);  
   openit (magicfname, &fff, "r") ;
   while (fgets(line, MAXSTR, fff) != NULL)  {
    nsplit = splitup(line, spt, MAXFF) ; 
    if (nsplit == 0) continue ;
    sx = spt[0] ;
    if ((sx[0] == '#')  || (nsplit<4)) { 
     freeup(spt, nsplit) ;
     continue ;
    }
    indnum = indindex(indm, numindivs, spt[0]) ;
    if (indnum<0) printf("(setmagic) %s not found in individual list\n", spt[0]) ;
    else {  
     for (k=0;  k<3 ; k++)  {
       xp[k] = atof(spt[k+1]) ;
     }
     copyarr(xp, magictable[indnum], 3) ;
    }
    freeup(spt, nsplit) ;
  }
  fclose(fff) ;
}

void magicgg(double *gg, int indnum) 
{
 if (magictable == NULL) fatalx("(magicgg) setmagic not called\n") ;
 copyarr(magictable[indnum], gg, 3) ;
}
