#include  <stdio.h>
#include <string.h>
#include <unistd.h>
#include <math.h>  

#include <nicklib.h>
#include <getpars.h> 
#include "admutils.h"
#include "mcio.h"  
#include "gammas.h" 
#include "tlest.h" 
#include "arms.h" 
#include "mcmcpars.h" 

/** 
 like admgd2 
 but tests  a range of snps
*/

int keeptrashfiles = YES ; 
int magicnum = -1 ;

int lonum = -1, hinum ; 

int  allsnps   = NO ;

int *fchrom, *lchrom ;

char *trashdir = "/var/tmp" ;
int qtmode = NO ;
int verbose = NO ;
int debug = NO ;

extern int packmode ;

Indiv **indivmarkers;
SNP **snpmarkers ;

int numsnps, numindivs ; 
int xchrom = -1 ;

double plo = .001 ;
double phi = .999 ;
double fakespacing = 0.01 ; 

double disnum = 0.0, dissum = 0.0 ;

char  *genotypename = NULL ;
char  *snpname = NULL ;
char  *genooutfilename = NULL ;
char  *indivname = NULL ;
char *badsnpname = NULL ;
char *tlname  = NULL ;
char *freqname  = NULL ;
char *gammafiles = NULL ;
char *output = NULL ; 

FILE  *ofile ;


double **ax[3] ; 
double **bx[3] ; 

#define VERSION    "1000"  

void readcommands(int argc, char **argv) ;
double scorex(SNP **snplist, int nlist, Indiv *indx,
 double *aaa, double *bbb, double *dd)  ;

int   
main  (int argc , char **argv) 
{
  int i, j, k ;
  int nwrite ;
  double y ;
  double dis = 0.1 ;  /* Morgans */
  double gg[3] ;

  SNP *cupt ;
  SNP *cupt1, *cupt2, *cupt3 ;

  Indiv *indx ;

  double gpos1,gpos2,cpos1,cpos2,gd, cd, gd100 ;
  double rthresh, zt ;
  int numvind  ;

  int ch1, ch2 ;
  int fmnum , lmnum ;
  int numind ;
  int num, n1, n2, x1, x2, x3, x  ;

  int nindiv = 0, e, f, lag=1  ;
  int nignore, numrisks = 1 ;
  double dmean, dsd ;

  packmode = NO ;
  readcommands(argc, argv) ;

  numsnps = 
    getsnps(snpname, &snpmarkers, fakespacing, badsnpname, &nignore, numrisks) ;


  numindivs = getindivs(indivname, &indivmarkers) ;
  setstatus(indivmarkers, numindivs, "Case") ;

  getgenos(genotypename, snpmarkers, indivmarkers, 
    numsnps, numindivs, nignore) ;


  numvind = numvalidind(indivmarkers, numindivs) ;
  printf("\n\n") ;
  printf("numindivs: %d valid: %d numsnps: %d nignore: %d\n" ,
    numindivs, numvind, numsnps, nignore) ; 

  setgfiles(snpmarkers, numsnps, numindivs, trashdir, gammafiles, 1) ;
  nwrite = 0 ;
  if (output == NULL) output = strdup(  "gammas") ;
  openit (output, &ofile, "w") ;
  for (i=0; i<numsnps; i++) {  
   cupt = snpmarkers[i] ; 
   printf("snp: %4d %s\n", i, cupt -> ID) ;
  }
  for (j=0; j<numindivs; j++) {  
   indx = indivmarkers[j] ; 
   printf("indiv: %4d %s\n", j, indx -> ID) ;
  }

  for (i=0; i<numsnps; i++) {  
   cupt = snpmarkers[i] ; 
   if (nwrite < -1) break ;
   for (j=0; j<numindivs; j++)  {  
    indx = indivmarkers[j] ; 
    grabgam(gg, i, j, 2) ; 
    bal1(gg, 3) ;  
    fprintf(ofile, "%4d %4d %6.3f %6.3f %6.3f\n", i, j, gg[0], gg[1], gg[2]) ;
//  printf("%4d %4d %6.3f %6.3f %6.3f\n", i, j, gg[0], gg[1], gg[2]) ;
    ++nwrite ;
    if (nwrite < -1) break ;
  }
 }
 if (output != NULL) fclose(ofile) ;

  return 0 ; 
}

void readcommands(int argc, char **argv) 

{
  int i ;
  char *parname = NULL ;
  phandle *ph ;
  char str[5000]  ;
  char *tempname ;
  int n ;

  while ((i = getopt (argc, argv, "o:p:vV")) != -1) {

    switch (i)
      {

      case 'p':
	parname = strdup(optarg) ;
	break;

      case 'o':
	output = strdup(optarg) ;
	break;

      case 'v':
	printf("version: %s\n", VERSION) ; 
	break; 

      case 'V':
	verbose = YES ;
	break; 

      case '?':
	printf ("Usage: bad params.... \n") ;
	fatalx("bad params\n") ;
      }
  }

         
   pcheck(parname,'p') ;
   printf("parameter file: %s\n", parname) ;
   ph = openpars(parname) ;
   dostrsub(ph) ;

/**
DIR2:  /fg/nfiles/admixdata/ms2
SSSS:  DIR2/outfiles 
genotypename: DIR2/autos_ccshad_fakes
eglistname:    DIR2/eurlist  
output:        eurout
*/
   getint(ph, "packmode:", &packmode) ; // controls internals 

   getstring(ph, "genotypename:", &genotypename) ;
   getstring(ph, "genooutfilename:", &genooutfilename) ;
   getstring(ph, "snpname:", &snpname) ;
   getstring(ph, "indivname:", &indivname) ;
   getstring(ph, "badsnpname:", &badsnpname) ;
   getstring(ph, "tlname:", &tlname) ;
   getstring(ph, "freqname:", &freqname) ;
   getstring(ph, "output:", &output) ;

   getstring(ph, "trashdir:", &trashdir) ;
   getstring(ph, "gammafiles:", &gammafiles) ;
   getdbl(ph, "fakespacing:", &fakespacing) ;


   writepars(ph) ;
   closepars(ph) ;

}
double addloga(double *x, int n)  
{

 double ylog ; 
 int i ;

 ylog = x[0] ;
 for (i=1; i<n; i++)  {
  ylog = addlog(ylog,  x[i]) ;
 }
 return ylog ;
}

