#include <stdio.h>
#include <limits.h>
#include <math.h>  
#include <nicklib.h> 
#include "eigsubs.h" 

/* ********************************************************************* */


#define M  50 
#define N  10000

double twnorm(double lam, double p, double n) ;

int main(void)
{
    double *mat, *v ;

    int numiter = 10  ; 
    int iter, n= N ;
    int m=M ;
    int k ;
    double mu, phi, lam, twstat ;
    double twsum = 0.0 ;

     SRAND(87) ;
     ZALLOC(mat, m*m, double) ;
     ZALLOC(v, m, double) ;

    for (iter = 1; iter <= numiter; ++iter) { 
     vzero(mat, m*m) ;
     for (k=0; k<n; k++) {
      gaussa(v, m) ;
      addouter(mat, v, m) ;
     }
     eigvals(mat, v, m) ;
     lam = v[0] ;
     twstat = twnorm(lam, (double) m, (double) n) ;
     printf("%3d  %9.3f\n",iter, twstat) ;
     twsum += twstat ;
    }
    printf("twmean: %9.3f\n", twsum/(double) numiter ) ;
}
double twnorm(double lam, double p, double n) 
// Ref Johnstone (2001) 
{ 
	 double mu, phi , y1, y2 , yy ; 
	 y1 = sqrt(n-1) + sqrt(p) ; 
	 mu = y1*y1 ;
	 y2 = (1.0/sqrt(n-1)) + 1.0/sqrt(p) ;  
         phi = y1*pow(y2,1.0/3.0) ;
	 return (lam-mu)/phi ;
 }
